<?php
namespace Teknisa\FAI\Modules\Relatorio\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Fai01300FaturamentoDeRefeicoesPorPeriodo extends \Zeedhi\Framework\Controller\Report {

    protected $connection;
    protected $environment;
    protected $newCode;
    protected $crudService;
    protected $qr2Strategy;
    protected $birtStrategy;

    public function __construct($reportService, $connection, $environment, $newCode, $crudService, $birtStrategy, $qr2Strategy) {
        $this->connection               = $connection;
        $this->environment              = $environment;
        $this->newCode                  = $newCode;
        $this->crudService              = $crudService;
        $this->birtStrategy             = $birtStrategy;
        $this->qr2Strategy              = $qr2Strategy;
        parent::__construct($reportService);
    }

    protected $reportMapping = array (
        'FAI01300' =>
        array (
            'strategy'          => 'BIRT',
            'parameterMapping'  =>
            array (
                'CDFILIAL'     => 'CDFILIAL',
                'NRAPURACGD'   => 'NRAPURACGD',
                'CDCLIENTE'    => 'CDCLIENTE',
                'INICIAL'      => 'DTINICIAL',
                'FINAL'        => 'DTFINAL',
                'QUEBRAFILIAL' => 'IDQUEBRAFILIAL',
                'NRORG'        => 'NRORG'
            )
        ),
        'FAI01301' =>
        array (
            'strategy'          => 'BIRT',
            'parameterMapping'  =>
            array (
                'CDFILIAL'     => 'CDFILIAL',
                'NRAPURACGD'   => 'NRAPURACGD',
                'CDCLIENTE'    => 'CDCLIENTE',
                'INICIAL'      => 'DTINICIAL',
                'FINAL'        => 'DTFINAL',
                'QUEBRAFILIAL' => 'IDQUEBRAFILIAL',
                'NRORG'        => 'NRORG'
            )
        ),
        'FAI01302' =>
        array (
            'strategy'          => 'BIRT',
            'parameterMapping'  =>
            array (
                'CDFILIAL'     => 'CDFILIAL',
                'NRAPURACGD'   => 'NRAPURACGD',
                'CDCLIENTE'    => 'CDCLIENTE',
                'INICIAL'      => 'DTINICIAL',
                'FINAL'        => 'DTFINAL',
                'QUEBRAFILIAL' => 'IDQUEBRAFILIAL',
                'NRORG'        => 'NRORG'
            )
        ),
        'FAI01303' =>
        array (
            'strategy'          => 'BIRT',
            'parameterMapping'  =>
            array (
                'CDFILIAL'     => 'CDFILIAL',
                'NRAPURACGD'   => 'NRAPURACGD',
                'CDCLIENTE'    => 'CDCLIENTE',
                'INICIAL'      => 'DTINICIAL',
                'FINAL'        => 'DTFINAL',
                'QUEBRAFILIAL' => 'IDQUEBRAFILIAL',
                'NRORG'        => 'NRORG'
            )
        ),
        'FAI01304' =>
        array (
            'strategy'          => 'BIRT',
            'parameterMapping'  =>
            array (
                'CDFILIAL'     => 'CDFILIAL',
                'NRAPURACGD'   => 'NRAPURACGD',
                'CDCLIENTE'    => 'CDCLIENTE',
                'INICIAL'      => 'DTINICIAL',
                'FINAL'        => 'DTFINAL',
                'QUEBRAFILIAL' => 'IDQUEBRAFILIAL',
                'NRORG'        => 'NRORG'
            )
        ),
        'FAI01305' =>
        array (
            'strategy'          => 'BIRT',
            'parameterMapping'  =>
            array (
                'CDFILIAL'     => 'CDFILIAL',
                'NRAPURACGD'   => 'NRAPURACGD',
                'CDCLIENTE'    => 'CDCLIENTE',
                'INICIAL'      => 'DTINICIAL',
                'FINAL'        => 'DTFINAL',
                'QUEBRAFILIAL' => 'IDQUEBRAFILIAL',
                'NRORG'        => 'NRORG'
            )
        ),
        'FAI01306' =>
        array (
            'strategy'          => 'BIRT',
            'parameterMapping'  =>
            array (
                'CDFILIAL'     => 'CDFILIAL',
                'NRAPURACGD'   => 'NRAPURACGD',
                'CDCLIENTE'    => 'CDCLIENTE',
                'INICIAL'      => 'DTINICIAL',
                'FINAL'        => 'DTFINAL',
                'QUEBRAFILIAL' => 'IDQUEBRAFILIAL',
                'NRORG'        => 'NRORG'
            )
        ),
        'FAI01307' =>
        array (
            'strategy'          => 'BIRT',
            'parameterMapping'  =>
            array (
                'CDFILIAL'          => 'CDFILIAL',
                'NRAPURACGD'        => 'NRAPURACGD',
                'CDCLIENTE'         => 'CDCLIENTE',
                'INICIAL'           => 'DTINICIAL',
                'FINAL'             => 'DTFINAL',
                'QUEBRAFILIAL'      => 'IDQUEBRAFILIAL',
                'IDCENTRAL'         => 'P_IDCENTRAL',
                'AGGREGATE_UNIT'    => 'P_AGREGADAS',
                'NRORG'             => 'NRORG'
            )
        ),
        'FAI01308' =>
        array (
            'strategy'          => 'BIRT',
            'parameterMapping'  =>
            array (
                'CDFILIAL'     => 'CDFILIAL',
                'NRAPURACGD'   => 'NRAPURACGD',
                'CDCLIENTE'    => 'CDCLIENTE',
                'INICIAL'      => 'DTINICIAL',
                'FINAL'        => 'DTFINAL',
                'QUEBRAFILIAL' => 'IDQUEBRAFILIAL',
                'NRORG'        => 'NRORG'
            )
        ),
        'FAI01309' =>
        array (
            'strategy'          => 'BIRT',
            'parameterMapping'  =>
            array (
                'CDFILIAL'     => 'CDFILIAL',
                'NRAPURACGD'   => 'NRAPURACGD',
                'CDCLIENTE'    => 'CDCLIENTE',
                'INICIAL'      => 'DTINICIAL',
                'FINAL'        => 'DTFINAL',
                'QUEBRAFILIAL' => 'IDQUEBRAFILIAL',
                'NRORG'        => 'NRORG'
            )
        ),
        'FAI0130A' =>
        array (
            'strategy'          => 'BIRT',
            'parameterMapping'  =>
            array (
                'CDFILIAL'     => 'CDFILIAL',
                'NRAPURACGD'   => 'NRAPURACGD',
                'CDCLIENTE'    => 'CDCLIENTE',
                'INICIAL'      => 'DTINICIAL',
                'FINAL'        => 'DTFINAL',
                'QUEBRAFILIAL' => 'IDQUEBRAFILIAL',
                'NRORG'        => 'NRORG'
            )
        ),
        'FAI0130B' =>
        array (
            'strategy'          => 'BIRT',
            'parameterMapping'  =>
            array (
                'CDFILIAL'     => 'CDFILIAL',
                'NRAPURACGD'   => 'NRAPURACGD',
                'CDCLIENTE'    => 'CDCLIENTE',
                'INICIAL'      => 'DTINICIAL',
                'FINAL'        => 'DTFINAL',
                'QUEBRAFILIAL' => 'IDQUEBRAFILIAL',
                'NRORG'        => 'NRORG'
            )
        )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        try{
            $row = $request->getRow();
            $row['CDFILIAL'] = $row['FILIAL'];
            
            $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
            
            $CDCENTRALFATURAMENTO = $row['CDFILIALCENTRAL'] ?? null;
            $row['IDCENTRAL'] = $CDCENTRALFATURAMENTO ? 'S' : 'N';
            
            $this->handleCentralUnit($row);
            
            if ($row["TCLIENTE"] !== "T") {
                $clientes = array();
                foreach($row["CLIENTE"] as $cliente){
                    array_push($clientes, $cliente["CDFILIAL"].$cliente["CDCLIENTE"]);
                }
            }
            
            $row["CDCLIENTE"] = $row["TCLIENTE"] === "T"? $row["TCLIENTE"]: $this->criarListaValores(implode($clientes, '_'));
            $row["NRORG"] = $this->environment->getNrOrgTrab();
            
            $this->callProcedureApurac($row);
        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
    }
    
    private function handleCentralUnit(&$row) {
        if(isset($row['CDFILIALCENTRAL']) && $row['CDFILIALCENTRAL']){
            $row['CDFILIAL'] = $row['CDFILIALCENTRAL'];
            $row['IDCENTRAL'] = 'S';
            $row['AGGREGATE_UNIT'] = $row['ALL_AGGREGATE_UNITS'] === 'T'
                ? $row['ALL_AGGREGATE_UNITS']
                : $this->criarListaValores(implode($row['AGGREGATE_UNIT'], '_'));
            
        } else {
            $row['AGGREGATE_UNIT'] = 'N';
            $row["CDFILIAL"] = $row["TFILIAL"] === "T"? $row["TFILIAL"]: $this->criarListaValores(implode($row["FILIAL"], '_'));
            
        }  
    }
    
    private function callProcedureApurac($row) {
        $procedureName = "APURAC_RELGESDIRETA";
        $nrapuracgd = $this->newCode->getCodeByTableName('RELAPURFATT', $this->environment->getNrOrgTrab(), 1 , 9);
        $row['NRAPURACGD'] = 'T'.$nrapuracgd;
        
        if(isset($row['CDFILIALCENTRAL']) && $row['CDFILIALCENTRAL']) {
            $row['CDFILIAL'] = $row['CDFILIALCENTRAL'];
            
            $this->executeProcedure($procedureName, $row['CDFILIALCENTRAL'], $row, 's');
            } else {
                $filiais = $row["TFILIAL"] === "T" ? $this->findFiliais() : $row["FILIAL"];
               
                foreach($filiais as $cdfilial) {
                    $this->executeProcedure($procedureName, $cdfilial, $row);
            }
        }
        
        $this->executeProcedure($procedureName, $row['CDFILIAL'], $row, $row['IDCENTRAL']);
    }
    
    private function findFiliais() {
        $conditions = array(
            array(
                "columnName" => "CDOPERADOR",
                "operator" => "=",
                "value" => $this->environment->getCdOperador()
            )
        );
        
        $rows = $this->crudService->getFilteredDataSet('filioper', $conditions)->getRows();
        
        $filiais = array();
        
        foreach($rows as $row) {
            array_push($filiais, $row['CDFILIAL']);
        }
        
        return $filiais;
    }
    
    private function findClientes($filiais) {
        $conditions = array(
            array(
                "columnName" => "CDFILIAL",
                "operator" => "IN",
                "value" => $filiais
            )
        );
        $rows = $this->crudService->getFilteredDataSet('cliente_clienfilial', $conditions)->getRows();
        
        $clientes = array();
        
        foreach($rows as $row) {
            array_push($clientes, $row['CDFILIAL'].$row['CDCLIENTE']);
        }
        
        return $clientes;
    }

    private function executeProcedure($procedureName, $cdfilial, $row, $P_CENTRAL = 'N'){
        $procedure = new StoredProcedure($this->connection, $procedureName);
        
        $procedure->addParam(new Param('P_CDFILIAL',   Param::PARAM_INPUT, $cdfilial));
        $procedure->addParam(new Param('P_DATAINI',    Param::PARAM_INPUT, $row['INICIAL']));
        $procedure->addParam(new Param('P_DATAFIN',    Param::PARAM_INPUT, $row['FINAL']));
        $procedure->addParam(new Param('P_NRAPURACGD', Param::PARAM_INPUT, $row['NRAPURACGD']));
        $procedure->addParam(new Param('P_CDCLIENTE',  Param::PARAM_INPUT, ''));
        $procedure->addParam(new Param('P_EQUIVALENCIA', Param::PARAM_INPUT, 'N'));
		$procedure->addParam(new Param('P_CENTRAL', Param::PARAM_INPUT, $P_CENTRAL));
		$procedure->addParam(new Param('P_NRLISTA_AGREGADAS', Param::PARAM_INPUT, $row['AGGREGATE_UNIT']));
        
        $procedure->execute();
    }
    
    //Criado no TCO: cria lista de valores recebendo string como parametro
    public function criarListaValores($valores){
        if(strlen($valores) <= 4000){
            return $valores;
        }else{
            $lista = explode('_',$valores);
            $nrlista = $this->newCode->getCodeByTableName('LISTA', $this->environment->getNrorgTrab(), 1, 10, false);
            try{
                foreach($lista as $key){
                    $this->insertLista($nrlista, $key);
                }
                return "_NRLISTA=".$nrlista;
            } catch(\Exception $e){
                throw $e;
            }
        }
    }
    
    //Criado no TCO: insere lista no banco
    public function insertLista($nrlista, $cdlista) {
        $params = array(
            "NRLISTA" => $nrlista,
            "CDLISTA" => $cdlista,
            "NRORG" => $this->environment->getNrorgTrab()
        );
        
        $sql = "INSERT INTO LISTA (NRLISTA, CDLISTA, NRORG) VALUES (:NRLISTA, :CDLISTA, :NRORG)";
        $query = $this->connection->prepare($sql);
        $query->execute($params);
    }
}